#include "arraymalloc.h"
#include <stdlib.h>
#include <stdio.h>


double **arraymalloc(int nx, int ny)
{
    int i;
    double **ddata;

    ddata = (double **) malloc(nx*sizeof(double *) + nx*ny*sizeof(double)); //size of pointers to stripes, and stripes themselves

    //point to first stripe
    ddata[0] = (double *) (ddata + nx);

    for(i=1; i < nx; i++)
    {
        //point to next stripes
        ddata[i] = ddata[i-1] + ny;
    }

    return ddata;
}



void*** malloc3d(int nx, int ny, int nz, int type_size, int* arr_size){
    void ***x;

    long sizz = nz*type_size; //size of stripe in z direction
    long sizy = ny*sizeof(void*) + ny*sizz; //size of y-z plane plus the pointers to the stripes
    long sizx = nx*sizeof(void**) + nx*sizy; //size of whole array

    *arr_size = sizx;

    x = (void***)malloc(sizx);

    long i, j;
    long offset;

    for (i=0;i<nx;i++){

        //location x[i] points to relative to first address of x
        offset = nx*sizeof(void**) + i*sizy;

        // tell x[i] to point to offset. (char*) needed to make pointer have stride of 1
        x[i] =  (void**) ((char*)x+(offset));

        for (j=0;j<ny;j++){
            //printf("%i %i\n",i,j);
            x[i][j] = (void*)((char*)x[i] + ny*sizeof(void*) + j*sizz);
        }
    }

    return x;

}
